<?php
class upyun{
	const END_POINT = "http://p0.api.upyun.com";
	private $bucketname;
    private $username;
    private $password;

	public function __construct($bucketname, $username, $password){

		$this->bucketname = $bucketname;
        $this->username = $username;
        $this->password = $password;

	}

	public function compress($source, $savepath, $app_name, $nturl){

		switch($app_name){
			case "compress":
				$tasks = base64_encode(json_encode(array(array('sources' => array($source),'save_as' => $savepath))));
				break;
			case "depress":
				$tasks = base64_encode(json_encode(array(array('sources' => $source,'save_as' => $savepath))));
				break;
			default:
				echo "app_name should be compress or depress";
				exit();
		}
		
		$uri = "/pretreatment/";
		$date = gmdate('D, d M Y H:i:s \G\M\T');
		$signature = base64_encode(hash_hmac("sha1", "POST&$uri&$date", md5("{$this->password}"), true));
		$header = array("Authorization:UPYUN {$this->username}:$signature", "Date:$date");
		$formdata = "service={$this->bucketname}&app_name=$app_name&notify_url=$nturl&tasks=$tasks";

		$ch = curl_init(self::END_POINT.$uri);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $formdata);
		curl_exec($ch);
		$rsp_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		echo "\n".$rsp_code;

	}

}

$upyun = new upyun("", "Ա˺", "Ա");
$upyun->compress("/1114222", "/1114223.zip", "compress", "http://1.1.1.1");



?>